/** This file is part of Domotz Agent.
 * Copyright (C) 2023 Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

//Only for testing purposes
var dhcpRequest = function (message, resourceLocator) {
    var logger = resourceLocator.log;
    var myConsole = resourceLocator.log.decorateLogs();
    var dhcpRequestCounters = resourceLocator.DHCPRequestCounters;

    return {
        describe: function () {
            return 'Simulate dhcp request';
        },
        execute: function (callback) {
            var macAddress = JSON.parse(message.payload)['mac'];
            dhcpRequestCounters.registerDHCPRequest(macAddress);
            callback(logger.getRawLogs());
            logger.flush();
        },
    };
};

module.exports.command = dhcpRequest;
