/** This file is part of Domotz Agent.
 * Copyright (C) 2023  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/

module.exports.command = function (message, resourceLocator) {
    var myConsole = resourceLocator.log.decorateLogs();

    return {
        describe: function () {
            return message.correlationId + ' - dig - ';
        },
        execute: function (callback) {
            myConsole.debug('execute - DIG: ' + ' payload is ' + JSON.stringify(message.payload));
            var customTimeout = message.payload.timeout;
            require('./domotz_proc_executor').execute(resourceLocator, 'domotz_dig ' + message.payload.arguments, customTimeout, callback);
        },
    };
};
