/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz UK LLP
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created by Massimiliano Cuzzoli <massi@domotz.com> on 06/10/16.
 *
 */

var counter = null;
var forceDiscover = false;

var snmpBasicDiscovery = function (resourceLocator) {
    var logger = resourceLocator.log.decorateLogs();

    var delayFastDiscoveries = resourceLocator.settingsManager.getSetting('configuration.settings.snmp.discovery.basic.delay_fast_discoveries', 0);
    var periodFastDiscoveries = resourceLocator.settingsManager.getSetting('configuration.settings.snmp.discovery.basic.period_fast_discoveries', 60);

    if (counter === null) {
        counter = periodFastDiscoveries - delayFastDiscoveries;
    }

    logger.info('forced %s counter => %s / %s ', forceDiscover, counter, periodFastDiscoveries);

    if (forceDiscover || counter === periodFastDiscoveries) {
        if (counter === periodFastDiscoveries) {
            counter = 0;
        }
        forceDiscover = false;

        resourceLocator.discovery.protocols_orchestrator.discover('snmp');
    }
    counter++;
};

var discoveryForcing = function () {
    forceDiscover = true;
};

module.exports.handler = snmpBasicDiscovery;
module.exports.discoveryForcing = discoveryForcing;
