/** This file is part of Domotz Agent.
 * Copyright (C) 2024 Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Created by Daniele Bucchi <d.bucchi@domotz.com> on 18/01/2024.
 */

var netgearManager = require('../../../../network_tools/netgearRouter/netgearManager');

module.exports.post = function (resourceLocator) {
    var log = resourceLocator.log;
    var myConsole = log.decorateLogs();
    return function (req, res) {
        var manager = netgearManager(resourceLocator.q, log);
        manager
            .unblockAllDevices()
            .then(function (data) {
                res.send(data);
            })
            .catch(function () {
                myConsole.error('Unable to unlock devices');
            });
    };
};
