/** This file is part of Domotz Agent.
 * Copyright (C) Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
/**
 *
 * Created by NI Team <dev@domotz.com> on 14/07/2023.
 */

module.exports = function (resourceLocator) {
    var engineClient = resourceLocator.engineRequest;

    function sendIpConflict(activeConflicts, solvedConflicts) {
        var payload = _preparePayload(activeConflicts, solvedConflicts);
        return engineClient.cachedSendWithPromise('/ip-conflict', 'POST', payload);
    }

    function _preparePayload(activeConflicts, solvedConflicts) {
        return { active_conflicts: activeConflicts, solved_conflicts: solvedConflicts };
    }

    function retrieveActiveIpConflicts() {
        return engineClient.cachedSendWithPromise('/ip-conflict', 'GET');
    }

    return {
        sendIpConflict: sendIpConflict,
        retrieveActiveIpConflicts: retrieveActiveIpConflicts,
    };
};
