/** This file is part of Domotz Agent.
 * Copyright (C)  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
/**
 *
 * Created by NI Team <dev@domotz.com> on 14/07/2023.
 */

module.exports = function (resourceLocator) {
    var settingsManager = resourceLocator.settingsManager;

    function isIpConflictEnabled() {
        return settingsManager.getSetting('configuration.settings.ip_conflict.enabled', true);
    }

    function ipConflictParallelism() {
        return settingsManager.getSetting('configuration.settings.ip_conflict.parallelism', 5);
    }

    function timeoutMsIpConflict() {
        return settingsManager.getSetting('configuration.settings.ip_conflict.timeout_ms', 1000);
    }

    function isBroadcastDiscoveryDisabled() {
        return settingsManager.isBroadcastDiscoveryDisabled();
    }

    function getIpConflictResolutionRetries() {
        return settingsManager.getSetting('configuration.settings.ip_conflict.conflict_resolution_retries', 5);
    }

    return {
        isIpConflictEnabled: isIpConflictEnabled,
        ipConflictParallelism: ipConflictParallelism,
        timeoutMsIpConflict: timeoutMsIpConflict,
        isBroadcastDiscoveryDisabled: isBroadcastDiscoveryDisabled,
        getIpConflictResolutionRetries: getIpConflictResolutionRetries,
    };
};
