/** This file is part of Domotz Agent.
 * Copyright (C) 2024 Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Created by Andrea Azzara <a.azzara@domotz.com> on 18/01/2024.
 */

module.exports.utils = function () {
    return {
        generateFirewallKey: function (macAddress, ipAddress) {
            return 'domotz_' + macAddress + '_' + ipAddress;
        },
        getIPsFromMACAddress: function (macAddress, freshBindings) {
            var ipAddresses = [];

            freshBindings.forEach(function (binding) {
                if (binding.mac === macAddress) {
                    ipAddresses.push(binding.ip);
                }
            });
            return ipAddresses;
        },
    };
};
